"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var router_1 = require('@angular/router');
var current_api_1 = require('./current-api');
var step_utils_1 = require('./step-utils');
var ApiListItems = (function () {
    function ApiListItems(router, utils, activated, parentRoute) {
        this.router = router;
        this.utils = utils;
        this.activated = activated;
        this.parentRoute = parentRoute;
    }
    ApiListItems.prototype.createLink = function (api) {
        if (this.apiData.isStaticApi) {
            return this.utils.createAbsoluteLink(this.apiData.apiVersion.version + '/' + api.urlName, this.parentRoute);
        }
        else {
            return this.utils.createAbsoluteLink(this.apiData.apiVersion.name + '/' + api.apiTitle, this.parentRoute);
        }
    };
    ApiListItems.prototype.isCurrent = function (url) {
        return this.router.url === url;
    };
    ApiListItems.prototype.getFiles = function () {
        var _this = this;
        if (this.apiData.isStaticApi) {
            var staticData = this.apiData.apiVersion;
            return staticData.files.map(function (item) {
                return {
                    apiTitle: item.name,
                    urlName: item.urlName
                };
            });
        }
        else {
            return this.apiData.apiDefinition.files
                .filter(function (file) {
                return (_this.apiData.apiVersion.exclude || []).indexOf(file.apiTitle) === -1;
            });
        }
    };
    ApiListItems.prototype.ngOnInit = function () {
        var _this = this;
        this.activated.api.subscribe(function (data) {
            _this.apiData = data;
        });
    };
    ApiListItems = __decorate([
        core_1.Component({
            selector: 'api-list-items',
            template: "\n<ul *ngIf=\"apiData\" class=\"apis-list\">\n    <li class=\"api-list-item\" *ngFor=\"let api of getFiles();\" [ngClass]=\"{'active-step': isCurrent(createLink(api))}\">\n        <a class=\"api-item-link\" [href]=\"createLink(api)\">{{ api.apiTitle }}</a>\n    </li>\n</ul>"
        }),
        core_1.Injectable(), 
        __metadata('design:paramtypes', [router_1.Router, step_utils_1.StepsUtils, current_api_1.ActivatedApi, router_1.ActivatedRoute])
    ], ApiListItems);
    return ApiListItems;
}());
exports.ApiListItems = ApiListItems;
//# sourceMappingURL=api-list-items.component.js.map