"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var _ = require('lodash');
var jsdoc2md = require('jsdoc-to-markdown');
var marked = require('marked');
var ApiLoadResolve = (function () {
    function ApiLoadResolve(http) {
        this.http = http;
    }
    ApiLoadResolve.prototype.escapeAngularBindings = function (html) {
        return html.replace(/[{}]/g, function (match) {
            return '<span>{{ \'' + match + '\' }}</span>';
        });
    };
    ApiLoadResolve.prototype.resolve = function (route) {
        var routeData = route.data;
        if (routeData.isStaticApi) {
            var apiFile_1 = routeData.apiFile;
            console.log('Loading URL: ', apiFile_1.markdownFilePath);
            return this.http
                .get(apiFile_1.markdownFilePath)
                .map(function (res) { return res.text(); })
                .map(function (text) { return marked(text); })
                .map(this.escapeAngularBindings)
                .map(function (parsedDocs) {
                return {
                    jsDoc: parsedDocs,
                    apiName: apiFile_1.name
                };
            });
        }
        else {
            var apiFile_2 = routeData.apiFile;
            var apiDefinition = routeData.apiDefinition;
            var apiVersion = routeData.apiVersion;
            var repo_1 = apiFile_2.apiRepository || apiDefinition.apiRepository;
            var revision_1 = apiFile_2.revision || apiVersion.revision;
            var filePath_1 = apiFile_2.filePath || apiFile_2.mdFile;
            var url = 'https://raw.githubusercontent.com/' + repo_1 + '/' + revision_1 + '/' + filePath_1;
            if (filePath_1.charAt(0) === '/' && filePath_1.toLowerCase().indexOf('.md') > -1) {
                url = filePath_1;
            }
            return this.http
                .get(url)
                .map(function (res) { return res.text(); })
                .map(function (sourceCode) {
                var fileExt = _.last(filePath_1.split('.')).toLowerCase();
                if (fileExt === 'md') {
                    return sourceCode;
                }
                return jsdoc2md.renderSync({ source: sourceCode, 'no-cache': true });
            })
                .map(function (text) { return marked(text); })
                .map(this.escapeAngularBindings)
                .map(function (parsedDocs) {
                return {
                    jsDoc: parsedDocs,
                    revision: revision_1,
                    repo: repo_1,
                    filePath: filePath_1,
                    apiName: apiFile_2.apiTitle
                };
            });
        }
    };
    ApiLoadResolve = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http])
    ], ApiLoadResolve);
    return ApiLoadResolve;
}());
exports.ApiLoadResolve = ApiLoadResolve;
//# sourceMappingURL=api-load-resolve.js.map