"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var router_1 = require('@angular/router');
var _ = require('lodash');
var current_api_1 = require('./current-api');
var step_utils_1 = require('./step-utils');
var ApiVersionsList = (function () {
    function ApiVersionsList(utils, activated, router, parentRoute) {
        this.utils = utils;
        this.activated = activated;
        this.router = router;
        this.parentRoute = parentRoute;
    }
    ApiVersionsList.prototype.createLink = function (version) {
        var urlSuffix = '';
        if (this.apiData.isStaticApi) {
            urlSuffix = version.files[0].urlName;
        }
        else {
            var apiDef = this.apiData.apiDefinition;
            var names = _.without.apply(_, [_.map(apiDef.files, function (item) { return item.apiTitle; })].concat((version.exclude || [])));
            urlSuffix = names[0];
        }
        return this.utils.createAbsoluteLink('../../' + version.name + '/' + urlSuffix, this.parentRoute.firstChild);
    };
    ApiVersionsList.prototype.isCurrent = function (url) {
        return this.router.url === url;
    };
    ApiVersionsList.prototype.getVersionsList = function () {
        if (this.apiData.isStaticApi) {
            return _.map(this.apiData.apiDefinition.apis, function (item) {
                return Object.assign({
                    name: item.version
                }, item);
            });
        }
        else {
            return this.apiData.apiDefinition.versions;
        }
    };
    ApiVersionsList.prototype.ngOnInit = function () {
        var _this = this;
        this.activated.api.subscribe(function (data) {
            _this.apiData = data;
        });
    };
    ApiVersionsList = __decorate([
        core_1.Component({
            selector: 'api-versions-list',
            template: "\n<ul *ngIf=\"apiData\" class=\"apis-versions-list\">\n    <li class=\"api-version-list-item\" *ngFor=\"let version of getVersionsList();\" [ngClass]=\"{'active-step': isCurrent(createLink(version))}\">\n        <a class=\"version-link\" [href]=\"createLink(version)\">{{version.visibleName || version.name}}</a>\n    </li>\n</ul>"
        }),
        core_1.Injectable(), 
        __metadata('design:paramtypes', [step_utils_1.StepsUtils, current_api_1.ActivatedApi, router_1.Router, router_1.ActivatedRoute])
    ], ApiVersionsList);
    return ApiVersionsList;
}());
exports.ApiVersionsList = ApiVersionsList;
//# sourceMappingURL=api-versions-list.component.js.map