"use strict";
var tutorial_page_component_1 = require('./tutorial-page.component');
var patch_load_resolver_1 = require('./patch-load-resolver');
function createTutorialsRoutes(tutorialsArray) {
    var config = [];
    tutorialsArray.forEach(function (tutorial) {
        var baseUrl = tutorial.baseRoute;
        Object.keys(tutorial.versions).forEach(function (tutorialGitIdentifier) {
            var versionData = tutorial.versions[tutorialGitIdentifier];
            var steps = versionData.steps;
            var isLatest = versionData.isLatest;
            var routeName = versionData.urlName;
            steps.forEach(function (step) {
                var stepUrl;
                if (isLatest) {
                    stepUrl = baseUrl + step.url;
                }
                else {
                    stepUrl = baseUrl + '/' + routeName + step.url;
                }
                config.push({
                    path: stepUrl,
                    component: tutorial_page_component_1.TutorialPage,
                    resolve: {
                        resolveData: patch_load_resolver_1.PatchLoadResolve
                    },
                    data: {
                        stepObject: step,
                        tutorialObject: tutorial,
                        steps: steps,
                        gitTagRevision: tutorialGitIdentifier
                    }
                });
            });
        });
    });
    return config;
}
exports.createTutorialsRoutes = createTutorialsRoutes;
//# sourceMappingURL=tutorial-routes.js.map